import React from 'react';
import { Atom, WritableAtom, AnyAtom } from './types';
import { ImmutableMap } from './immutableMap';
export declare type AtomState<Value = unknown> = {
    readE?: Error;
    readP?: Promise<void>;
    writeP?: Promise<void>;
    value?: Value;
    deps: Set<AnyAtom>;
};
declare type State = ImmutableMap<AnyAtom, AtomState>;
export declare type Actions = {
    add: <Value>(id: symbol, atom: Atom<Value>) => void;
    del: <Value>(id: symbol, atom: Atom<Value>) => void;
    read: <Value>(state: State, atom: Atom<Value>) => AtomState<Value>;
    write: <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void | Promise<void>;
};
export declare const ActionsContext: React.Context<Actions>;
export declare const StateContext: React.Context<ImmutableMap<Atom<unknown>, AtomState<unknown>>>;
export declare const Provider: React.FC;
export {};
