export declare type ImmutableMap<K, V> = Map<K, V>[];
declare type MCreate = <K, V>() => ImmutableMap<K, V>;
declare type MGet = <K, V>(m: ImmutableMap<K, V>, k: K) => V | undefined;
declare type MSet = <K, V>(m: ImmutableMap<K, V>, k: K, v: V) => ImmutableMap<K, V>;
declare type MDel = <K, V>(m: ImmutableMap<K, V>, k: K) => ImmutableMap<K, V>;
declare type MKeys = <K, V>(m: ImmutableMap<K, V>) => Set<K>;
declare type MMerge = <K, V>(m: ImmutableMap<K, V>, newM: ImmutableMap<K, V>) => ImmutableMap<K, V>;
declare type MToPrintable = <K, V>(m: ImmutableMap<K, V>, toPrintableK: (k: K) => unknown, toPrintableV: (v: V) => unknown) => unknown;
export declare const mCreate: MCreate;
export declare const mGet: MGet;
export declare const mSet: MSet;
export declare const mDel: MDel;
export declare const mKeys: MKeys;
export declare const mMerge: MMerge;
export declare const mToPrintable: MToPrintable;
export {};
